import { Injectable } from '@nestjs/common';
import { BaseIndexManager } from 'src/core/modules/domain/usecase/managers/base-index.manager';
import { UserPrivilegeEntity } from '../../../entities/user-privilege.entity';
import { SelectQueryBuilder } from 'typeorm';
import { TABLE_NAME } from 'src/core/strings/constants/table.constants';
import { Param } from 'src/core/helpers/query/specific-search.helper';

@Injectable()
export class IndexUserPrivilegeManager extends BaseIndexManager<UserPrivilegeEntity> {
  async prepareData(): Promise<void> {
    this.tableName = TABLE_NAME.USER_PRIVILEGE;
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get specificFilter(): Param[] {
    return [];
  }

  setQueryFilter(
    queryBuilder: SelectQueryBuilder<UserPrivilegeEntity>,
  ): SelectQueryBuilder<UserPrivilegeEntity> {
    return queryBuilder;
  }

  setFilterSearch(): string[] {
    return [];
  }
}
